#include <iostream>
#include <boost/shared_ptr.hpp>
#include <boost/make_shared.hpp>
#include "list.hpp"

using namespace std;

struct Object {
   Object(int _i) : i(_i) {};
   ~Object() {
      cout << "destroying object " << i << endl;
   }
   int i;
};

ostream& operator<<(ostream& out, const Object& obj) {
   return out << obj.i;
}

int main() {
   List<boost::shared_ptr<Object> > list;
   for (int i = 0; i < 10; ++i) {
      list.push_back(boost::make_shared<Object>(i));
   }
   for (List<boost::shared_ptr<Object> >::Iterator it = list.begin();
	 it != list.end(); ++it) {
      cout << **it << endl;
   }
}
